----------------------------------------------------------------------------
-- $Id: request.lua,v 1.2 2007/01/31 13:11:37 zhaozg Exp $
----------------------------------------------------------------------------

local ap = ap
local assert = assert

module"SAPI.request"

----------------------------------------------------------------------------
-- Input general information
local ap_func = {
	AUTH_TYPE = ap.auth_type,
	CONTENT_LENGTH = function ()
		return ap.get_header ("Content-length")
	end,
	CONTENT_TYPE = function ()
		return ap.get_header ("Content-type")
	end,
	GATEWAY_INTERFACE = function () return "CGI/1.1" end,
	HTTP_COOKIE = function () return ap.get_header ("Cookie") end,
	HTTP_REFERER = function () return ap.get_header ("Referer") end,
	PATH_INFO = ap.path_info,  -- !!!!!!!!!!!!!!!! see server/util_script.c
	PATH_TRANSLATED = ap.filename,  -- !!!!!!!!!!!!!!!! see server/util_script.c
	QUERY_STRING = ap.args,
	REMOTE_ADDR = function ()
		return ap.conn_remote_addr ()
	end,
	REMOTE_HOST = ap.get_remote_host,
	REMOTE_PORT = ap.port,
	REMOTE_USER = ap.user,
	REQUEST_METHOD = ap.method,
	SCRIPT_NAME = ap.uri,  -- !!!!!!!!!!!!!!!! see server/util_script.c
	SERVER_NAME = ap.get_server_name,
	SERVER_PORT = ap.get_server_port,
	SERVER_PROTOCOL = ap.protocol,
	SERVER_SOFTWARE = ap.get_server_version,
}

----------------------------------------------------------------------------
function open ()
	local first_get_post = true
	return {
		servervariable = function (n)
			local f = ap_func[n]
			return f and f()
		end,

		getpostdata = function (n)
			if first_get_post then
				assert (ap.setup_client_block ("REQUEST_CHUNKED_ERROR") == ap.OK)
				first_get_post = false
				if ap.should_client_block () ~= 0 then
					return ap.get_client_block (n)
				end
			else
				return ap.get_client_block (n)
			end
		end,
		reset = function()
			first_get_post = true
		end,
		       
	}
end
